from __future__ import annotations
from typing import Any, Protocol, runtime_checkable
from com.sun.star.uno import XInterface

@runtime_checkable
class XDockableWindow(XInterface, Protocol):
    def addDockableWindowListener(self, xListener: XDockableWindowListener) -> None: ...
    def removeDockableWindowListener(self, xListener: XDockableWindowListener) -> None: ...
    def enableDocking(self, bEnable: bool) -> None: ...
    def isFloating(self) -> bool: ...
    def setFloatingMode(self, bFloating: bool) -> None: ...
    def lock(self) -> None: ...
    def unlock(self) -> None: ...
    def isLocked(self) -> bool: ...
    def startPopupMode(self, WindowRect: Rectangle) -> None: ...
    def isInPopupMode(self) -> bool: ...
